{  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> BEGIN INCLUDE >>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   Filename :  DISPLAY.INC
}
PROCEDURE DISPLAY (DEV : STRING4; P : BUFFTYPE; DISP : INTEGER);
{  ***************************************************************************
   Display 128 bytes in HEX and ASCII given the starting address (AD), and
   an offset (DISP) to display.
   ***************************************************************************
}
VAR
   I,J     : INTEGER;
   DEVICE  : TEXT;

BEGIN
   ASSIGN (DEVICE,DEV);
   REWRITE (DEVICE);
   LOWVIDEO;
   WRITE (DEVICE,' ':6);
   FOR I := 0 TO 15 DO WRITE (DEVICE,HEX(I),' ');
   WRITE (DEVICE,'    ');
   WRITE (DEVICE,'0123456789ABCDEF');
   IF DEV = 'LST:' THEN
   BEGIN
      WRITE (DEVICE,CR,'':6);
      WRITE (DEVICE,REPLICATE(47,'_'),'':5,REPLICATE(16,'_'));
      WRITELN (DEVICE);
   END
   ELSE
      WRITELN (DEVICE);
   FOR I := 0 TO 7 DO
   BEGIN
      LOWVIDEO;
      WRITE (DEVICE,HEX(I*16+DISP):4,'  ');
      HIGHVIDEO;
      FOR J := 0 TO 15 DO
      BEGIN
         WRITE (DEVICE,HEX(P[I*16+J]),' ');
      END;
      WRITE (DEVICE,'    ');
      FOR J := 0 TO 15 DO
      BEGIN
         IF (P[I*16+J] < $7F) AND
            (P[I*16+J] > $1F) THEN
         BEGIN
            HIGHVIDEO;
            WRITE (DEVICE,CHR(P[I*16+J]));
         END
         ELSE
         BEGIN
            LOWVIDEO;
            WRITE (DEVICE,'.');
         END;
      END;
      WRITELN (DEVICE);
      HIGHVIDEO;
   END;
   CLOSE (DEVICE);
END; { DISPLAY }


{  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< END INCLUDE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
}

